#pragma once

// SPI2PAR

#define SPI2PAR_CURSORHOME 1
#define SPI2PAR_HIDEDISPLAY 2
#define SPI2PAR_SHOWDISPLAY 3
#define SPI2PAR_HIDECURSOR 4
#define SPI2PAR_SHOWUNDERLINECURSOR 5
#define SPI2PAR_SHOWBLOCKCURSOR 6
#define SPI2PAR_SHOWINVERTEDCURSOR 7
#define SPI2PAR_BACKSPACE 8
#define SPI2PAR_MODULECONFIG 9
#define SPI2PAR_LINEFEED 10
#define SPI2PAR_DELETEINPLACE 11
#define SPI2PAR_FORMFEED 12
#define SPI2PAR_CARRIAGERETURN 13
#define SPI2PAR_SETBACKLIGHT 14
#define SPI2PAR_SETCONTRAST 15
#define SPI2PAR_SETCURSORPOSITION 17
#define SPI2PAR_DRAWBARGRAPH 18 
#define SPI2PAR_SCROLLON 19
#define SPI2PAR_SCROLLOFF 20
#define SPI2PAR_WRAPON 23
#define SPI2PAR_WRAPOFF 24
#define SPI2PAR_CUSTOMCHARACTER 25
#define SPI2PAR_REBOOT 26
#define SPI2PAR_CURSORMOVE 27 
#define SPI2PAR_LARGENUMBER 28

// Modxo

#define MODXO_LCD_DELAY 2
#define MODXO_LCD_COMMAND_MODE 0x80
#define MODXO_LCD_DATA_MODE 0x40

#define MODXO_PIXEL_FORMAT_GRB 0
#define MODXO_PIXEL_FORMAT_RGB 1
#define MODXO_PIXEL_FORMAT_BRG 2
#define MODXO_PIXEL_FORMAT_RBG 3
#define MODXO_PIXEL_FORMAT_BGR 4
#define MODXO_PIXEL_FORMAT_GBR 5

#define MODXO_NVM_REGISTER_RGB_STATUS_PF 1
#define MODXO_NVM_REGISTER_RGB_STRIP1_PF 2
#define MODXO_NVM_REGISTER_RGB_STRIP2_PF 3
#define MODXO_NVM_REGISTER_RGB_STRIP3_PF 4
#define MODXO_NVM_REGISTER_RGB_STRIP4_PF 5

#define MODXO_REGISTER_NVM_CONFIG_SEL 0xDEA4
#define MODXO_REGISTER_NVM_CONFIG_VAL 0xDEA5
#define MODXO_REGISTER_VOLATILE_CONFIG_SEL 0xDEA6
#define MODXO_REGISTER_VOLATILE_CONFIG_VAL 0xDEA7
#define MODXO_REGISTER_LCD_COMMAND 0xDEA8
#define MODXO_REGISTER_LCD_DATA 0xDEA9
#define MODXO_REGISTER_BANKING 0xDEAA
#define MODXO_REGISTER_SIZE 0xDEAB
#define MODXO_REGISTER_MEM_ERASE 0xDEAC
#define MODXO_REGISTER_CHIP_ID 0xDEAD
#define MODXO_REGISTER_MEM_FLUSH 0xDEAE
#define MODXO_REGISTER_LED_COMMAND 0xA2
#define MODXO_REGISTER_LED_DATA 0xA3

#define MODXO_BANK_TSOP 0xc0
#define MODXO_BANK_MODXO 0x00 
#define MODXO_BANK_BOOTLOADER 0x01
#define MODXO_BANK_PROMETHEOS1 0x02
#define MODXO_BANK_PROMETHEOS2 0x03

#define MODXO_LCD_SPI 0x00
#define MODXO_LCD_I2C 0x01
#define MODXO_LCD_REMOVE_I2C_PREFIX 2
#define MODXO_LCD_SET_I2C_PREFIX 3
#define MODXO_LCD_SET_CLK 4
#define MODXO_LCD_SET_SPI_MODE 5

#define MODXO_LED_CMD_SET_LED_COUNT_STRIP 0x00
#define MODXO_LED_CMD_FILL_STRIP_COL 0x01
#define MODXO_LED_CMD_UPDATE_STRIPS 0x02
#define MODXO_LED_CMD_SET_PIX_IDX 0x03
#define MODXO_LED_CMD_WRITE_PIX_COL 0x04
#define MODXO_LED_CMD_SET_PIX_COUNT 0x05
#define MODXO_LED_CMD_WRITE_EFFECT 0x06
#define MODXO_LED_CMD_SELECT_COLOR 0xF0
#define MODXO_LED_CMD_SELECT_STRIP 0xFC

#define MODXO_EFFECT_PIXELS_SHIFT_UP 0x01
#define MODXO_EFFECT_PIXELS_SHIFT_DOWN 0x02
#define MODXO_EFFECT_PIXELS_FADE 0x03
#define MODXO_EFFECT_PIXELS_RANDOM 0x04
#define MODXO_EFFECT_PIXELS_RAINBOW 0x05
#define MODXO_EFFECT_PIXELS_BRIGHTNESS 0x06

// Aladdin

#define ALADDIN_LCD_DELAY 2

#define ALADDIN_REGISTER_IO 0xF70Du
#define ALADDIN_REGISTER_DISP_O 0xF700u
#define ALADDIN_REGISTER_LCD_BL 0xF701u
#define ALADDIN_REGISTER_LCD_CT 0xF703u
#define ALADDIN_REGISTER_GPIO 0xF70D
#define ALADDIN_REGISTER_BANKING 0xF70F

#define ALADDIN_SPI_CS_BIT 0x08
#define ALADDIN_SPI_MOSI_BIT 0x40
#define ALADDIN_SPI_CLK_BIT 0x20

#define ALADDIN_DISP_EXT_CONTROL 0x08
#define ALADDIN_DISP_NW_FLAG 0x01
#define ALADDIN_DISP_CON_RS 0x01
#define ALADDIN_DISP_CON_RW 0x02
#define ALADDIN_DISP_CON_E 0x04
#define ALADDIN_DISP_INI 0x01
#define ALADDIN_DISP_CMD 0x00
#define ALADDIN_DISP_DAT 0x02
#define ALADDIN_DISP_CLEAR 0x01
#define ALADDIN_DISP_HOME 0x02
#define ALADDIN_DISP_ENTRY_MODE_SET	0x04
#define ALADDIN_DISP_S_FLAG 0x01
#define ALADDIN_DISP_ID_FLAG 0x02
#define ALADDIN_DISP_CONTROL 0x08
#define ALADDIN_DISP_D_FLAG 0x04
#define ALADDIN_DISP_C_FLAG 0x02
#define ALADDIN_DISP_B_FLAG 0x01
#define ALADDIN_DISP_SHIFT 0x10
#define ALADDIN_DISP_SC_FLAG 0x08
#define ALADDIN_DISP_RL_FLAG 0x04
#define ALADDIN_DISP_FUNCTION_SET 0x20
#define ALADDIN_DISP_DL_FLAG 0x10
#define ALADDIN_DISP_N_FLAG 0x08
#define ALADDIN_DISP_F_FLAG 0x04
#define ALADDIN_DISP_RE_FLAG 0x04
#define ALADDIN_DISP_CGRAM_SET 0x40
#define ALADDIN_DISP_SEGRAM_SET 0x40
#define ALADDIN_DISP_DDRAM_SET 0x80
#define ALADDIN_DISP_EN5V 0x01

#define ALADDIN1MB_BANK_TSOP 0
#define ALADDIN1MB_BANK_BOOTLOADER 0x87
#define ALADDIN1MB_BANK_PROMETHEOS 0x84
#define ALADDIN1MB_BANK_SLOT1_256K 0x86
#define ALADDIN1MB_SETTINGS_BANK ALADDIN1MB_BANK_PROMETHEOS
#define ALADDIN1MB_SETTINGS_OFFSET (0x07f000)

#define ALADDIN2MB_BANK_TSOP 0
#define ALADDIN2MB_BANK_MEM_REGISTER 0x1F
#define ALADDIN2MB_BANK_SLOT1_256K 0x10
#define ALADDIN2MB_BANK_SLOT2_256K 0x11
#define ALADDIN2MB_BANK_SLOT3_256K 0x12
#define ALADDIN2MB_BANK_SLOT4_256K 0x13
#define ALADDIN2MB_BANK_SLOT1_512K 0x18
#define ALADDIN2MB_BANK_SLOT2_512K 0x19
#define ALADDIN2MB_BANK_SLOT1_1024K 0x1a
#define ALADDIN2MB_BANK_BOOTLOADER 0x14
#define ALADDIN2MB_BANK_PROMETHEOS1 0x15
#define ALADDIN2MB_BANK_PROMETHEOS2 0x16 
#define ALADDIN2MB_BANK_PROMETHEOS3 0x17 
#define ALADDIN2MB_SETTINGS_BANK ALADDIN2MB_BANK_PROMETHEOS3
#define ALADDIN2MB_SETTINGS_OFFSET (0x1ff000 - 0x1c0000)
#define ALADDIN2MB_INSTALLER_LOGO_BANK ALADDIN2MB_BANK_PROMETHEOS3
#define ALADDIN2MB_INSTALLER_LOGO_OFFSET (0x1f7000 - 0x1c0000)

//Smartxx

#define SMARTXX_LCD_DELAY 2

#define SMARTXX_REGISTER_BANKING 0x00EF
#define SMARTXX_REGISTER_LED 0x00EE
#define SMARTXX_SPI_MOSI_BIT 0x10
#define SMARTXX_SPI_CS_BIT 0x20
#define SMARTXX_SPI_CLK_BIT 0x40

#define SMARTXX_BANK_TSOP 0
#define SMARTXX_BANK_BOOTLOADER 1
#define SMARTXX_BANK_PROMETHEOS1 2
#define SMARTXX_BANK_PROMETHEOS2 10
#define SMARTXX_BANK_SLOT1_256K 3
#define SMARTXX_BANK_SLOT2_256K 4
#define SMARTXX_BANK_SLOT3_256K 5
#define SMARTXX_BANK_SLOT4_256K 6
#define SMARTXX_BANK_SLOT1_512K 7
#define SMARTXX_BANK_SLOT2_512K 8
#define SMARTXX_BANK_SLOT1_1024K 9
#define SMARTXX_SETTINGS_BANK SMARTXX_BANK_PROMETHEOS2
#define SMARTXX_SETTINGS_OFFSET (0x1f8000 - 0x1c0000)
#define SMARTXX_INSTALLER_LOGO_BANK SMARTXX_BANK_PROMETHEOS2
#define SMARTXX_INSTALLER_LOGO_OFFSET (0x1fa000 - 0x1c0000)

//Xecuter

#define XECUTER_LCD_DELAY 2

#define XECUTER_REGISTER_HARDWARE_BANKING 0xF501
#define XECUTER_REGISTER_SOFTWARE_BANKING 0xF502
#define XECUTER_REGISTER_LED 0x00EE
#define XECUTER_SPI_MOSI_BIT 0x10
#define XECUTER_SPI_CS_BIT 0x20
#define XECUTER_SPI_CLK_BIT 0x40

#define XECUTER_BANK_TSOP 0x6f
#define XECUTER_BANK_BACKUP_256K 0x8f 
#define XECUTER_DISABLE_BACKUP 0xf 

#define XECUTER_BANK_BOOTLOADER 0x00
#define XECUTER_BANK_PROMETHEOS1 0x01
#define XECUTER_BANK_PROMETHEOS2 0x02
#define XECUTER_BANK_PROMETHEOS3 0x03
#define XECUTER_BANK_SLOT1_256K 0x04
#define XECUTER_BANK_SLOT2_256K 0x05
#define XECUTER_BANK_SLOT3_256K 0x06
#define XECUTER_BANK_SLOT4_256K 0x07
#define XECUTER_BANK_SLOT1_512K 0x0a
#define XECUTER_BANK_SLOT2_512K 0x0b
#define XECUTER_BANK_SLOT1_1024K 0x0d

#define XECUTER_SETTINGS_BANK XECUTER_BANK_PROMETHEOS3
#define XECUTER_SETTINGS_OFFSET (0x0f0000 - 0x0c0000)
#define XECUTER_INSTALLER_LOGO_BANK XECUTER_BANK_PROMETHEOS3
#define XECUTER_INSTALLER_LOGO_OFFSET (0x0e0000 - 0x0c0000)

#define XECUTER_REGISTER_DISP_O_LIGHT 0xf503
#define XECUTER_REGISTER_DISP_O_DAT 0xf504
#define XECUTER_REGISTER_DISP_O_CMD 0xf505
#define XECUTER_REGISTER_DISP_O_DIR_DAT 0xf506
#define XECUTER_REGISTER_DISP_O_DIR_CMD 0xf507

#define XECUTER_DISP_CON_RS 0x01
#define XECUTER_DISP_CON_RW 0x02
#define XECUTER_DISP_CON_E 0x04
#define XECUTER_DISP_INI 0x01
#define XECUTER_DISP_CMD 0x00
#define XECUTER_DISP_DAT 0x02
#define XECUTER_DISP_CLEAR 0x01
#define XECUTER_DISP_HOME 0x02
#define XECUTER_DISP_ENTRY_MODE_SET	0x04
#define XECUTER_DISP_S_FLAG 0x01
#define XECUTER_DISP_ID_FLAG 0x02
#define XECUTER_DISP_CONTROL 0x08
#define XECUTER_DISP_D_FLAG 0x04
#define XECUTER_DISP_C_FLAG 0x02
#define XECUTER_DISP_B_FLAG 0x01
#define XECUTER_DISP_SHIFT 0x10
#define XECUTER_DISP_SC_FLAG 0x08
#define XECUTER_DISP_RL_FLAG 0x04
#define XECUTER_DISP_FUNCTION_SET 0x20
#define XECUTER_DISP_DL_FLAG 0x10
#define XECUTER_DISP_N_FLAG 0x08
#define XECUTER_DISP_F_FLAG 0x04
#define XECUTER_DISP_RE_FLAG 0x04
#define XECUTER_DISP_CGRAM_SET 0x40
#define XECUTER_DISP_SEGRAM_SET 0x40
#define XECUTER_DISP_DDRAM_SET 0x80

//Xenium

#define XENIUM_LCD_DELAY 2

#define XENIUM_REGISTER_BANKING 0x00EF
#define XENIUM_REGISTER_LED 0x00EE
#define XENIUM_SPI_MOSI_BIT 0x10
#define XENIUM_SPI_CS_BIT 0x20
#define XENIUM_SPI_CLK_BIT 0x40

#define XENIUM_BANK_TSOP 0
#define XENIUM_BANK_BOOTLOADER 1
#define XENIUM_BANK_PROMETHEOS1 2
#define XENIUM_BANK_PROMETHEOS2 10
#define XENIUM_BANK_SLOT1_256K 3
#define XENIUM_BANK_SLOT2_256K 4
#define XENIUM_BANK_SLOT3_256K 5
#define XENIUM_BANK_SLOT4_256K 6
#define XENIUM_BANK_SLOT1_512K 7
#define XENIUM_BANK_SLOT2_512K 8
#define XENIUM_BANK_SLOT1_1024K 9
#define XENIUM_SETTINGS_BANK XENIUM_BANK_PROMETHEOS2
#define XENIUM_SETTINGS_OFFSET (0x1f8000 - 0x1c0000)
#define XENIUM_INSTALLER_LOGO_BANK XENIUM_BANK_PROMETHEOS2
#define XENIUM_INSTALLER_LOGO_OFFSET (0x1fa000 - 0x1c0000)

//XTREMIUM

#define XTREMIUM_LCD_DELAY 2

#define XTREMIUM_REGISTER_BANKING 0x00c
#define XTREMIUM_REGISTER_LED 0x00EE
#define XTREMIUM_SPI_MOSI_BIT 0x10
#define XTREMIUM_SPI_CS_BIT 0x20
#define XTREMIUM_SPI_CLK_BIT 0x40

#define XTREMIUM_BANK_TSOP 0
#define XTREMIUM_BANK_BOOTLOADER 1
#define XTREMIUM_BANK_PROMETHEOS1 2
#define XTREMIUM_BANK_PROMETHEOS2 10
#define XTREMIUM_BANK_SLOT1_256K 3
#define XTREMIUM_BANK_SLOT2_256K 4
#define XTREMIUM_BANK_SLOT3_256K 5
#define XTREMIUM_BANK_SLOT4_256K 6
#define XTREMIUM_BANK_SLOT1_512K 7
#define XTREMIUM_BANK_SLOT2_512K 8
#define XTREMIUM_BANK_SLOT1_1024K 9
#define XTREMIUM_SETTINGS_BANK XTREMIUM_BANK_PROMETHEOS2
#define XTREMIUM_SETTINGS_OFFSET (0x1f8000 - 0x1c0000)
#define XTREMIUM_INSTALLER_LOGO_BANK XTREMIUM_BANK_PROMETHEOS2
#define XTREMIUM_INSTALLER_LOGO_OFFSET (0x1fa000 - 0x1c0000)